Bug 629441 - (CVE-2010-3067) CVE-2010-3067 kernel: do_io_submit() infoleak
CVE-2010-3067 kernel: do_io_submit() infoleak
Status: NEW
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
low Severity low
: ---
: ---
Assigned To: Red Hat Product Security
impact=low,reported=20100902,public=2...
: Security
Depends On: 629444 629445 629446 629447 629448 629449 629450 629451
Blocks:
  Show dependency treegraph
 
Reported: 2010-09-01 21:48 EDT by Eugene Teo (Security Response)
Modified: 2015-08-31 23:55 EDT (History)
20 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Eugene Teo (Security Response) 2010-09-01 21:48:50 EDT
Description of problem:
This doesn't look correct, the io_submit systemcall calls do_io_submit() directly:

SYSCALL_DEFINE3(io_submit, aio_context_t, ctx_id, long, nr,
        struct iocb __user * __user *, iocbpp)
{
    return do_io_submit(ctx_id, nr, iocbpp, 0);
}

do_io_submit only checks if nr < 0, but doesnt check if the access_ok
multiplication will overflow.

long do_io_submit(aio_context_t ctx_id, long nr,
          struct iocb __user *__user *iocbpp, bool compat)
{
...
    if (unlikely(!access_ok(VERIFY_READ, iocbpp, (nr*sizeof(*iocbpp)))))
        return -EFAULT;
...

Then it uses this loop with __get_user_nocheck(), which doesn't look safe.

...
    for (i=0; i<nr; i++) {
        struct iocb __user *user_iocb;
        struct iocb tmp;

        if (unlikely(__get_user(user_iocb, iocbpp + i))) {
            ret = -EFAULT;
            break;
        }
...

Acknowledgements:

Red Hat would like to thank Tavis Ormandy for reporting this issue.
Comment 8 errata-xmlrpc 2010-10-07 22:12:29 EDT
This issue has been addressed in following products:

  MRG for RHEL-5

Via RHSA-2010:0758 https://rhn.redhat.com/errata/RHSA-2010-0758.html
Comment 11 errata-xmlrpc 2010-10-19 14:48:08 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 4

Via RHSA-2010:0779 https://rhn.redhat.com/errata/RHSA-2010-0779.html
Comment 12 errata-xmlrpc 2010-11-09 13:06:43 EST
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5

Via RHSA-2010:0839 https://rhn.redhat.com/errata/RHSA-2010-0839.html
Comment 13 errata-xmlrpc 2011-01-11 14:46:01 EST
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2011:0007 https://rhn.redhat.com/errata/RHSA-2011-0007.html

Note You need to log in before you can comment on or make changes to this bug.